app.controller('AppCtrl', function( $scope, $ionicModal, $ionicPopup, $timeout, $location, TemplateLoader, DataLoader, $templateCache, $rootScope, $stateParams ) {

	// fetch the language file to load string string variables i18n
	DataLoader.loadLanguage();

	// reloads app and busts cache
	$scope.reloadApp = function() {
		if ( window.cache ) {
			window.cache.clear( success, error );
		}
		window.location.reload();
	}

	// cache busting
	var success = function(status) {
        console.log('Message: ' + decodeURI(status) );
    }

    var error = function(status) {
        console.error('Error: ' + decodeURI(status) );
    }

	setTimeout( function() {

		if( isOffline ) {

			var alertPopup = $ionicPopup.alert({
		     	title: REACTOR_TEXT['offline_header'],
			 	template: REACTOR_TEXT['offline_body']
			});

		   alertPopup.then(function(res) {
		   });

		}

	}, 1000);

	// resume event listener
	document.addEventListener( 'resume', onResume, false );

	// check app api on resume
	function onResume() {

		var data = DataLoader.getAppData(api2);
		var localdata = JSON.parse( localStorage.getItem('localData') );

	    data.success( function( data, status, headers, config ) {

		    localStorage.setItem( 'localData', JSON.stringify( data ) );

			if( data['meta']['app_update_version'] === localdata['meta']['app_update_version'] ) return;

	    	APPDATA = data;
	        pushData(data);
	    });

	    data.error( function( data, status, headers, config ) {
	        console.error('update failed!');
	    });
	}

	// gets app-data.js file
	$scope.loadAppData = function() {

		if( localStorage.getItem('localData') ) {
			var data = JSON.parse( localStorage.getItem('localData') );
			APPDATA = data;
		    pushData(data);
		} else {
			var data = DataLoader.getAppData(app_data);
			data.success( function( data, status, headers, config ) {
		    	APPDATA = data;
		        pushData(data);
		        onResume();
		    });

		    data.error( function( data, status, headers, config ) {
		        console.error('Loading data failed!');
		    });
		}

    }

	// pushes app-data.js file data to app
	var pushData = function( json ) {

	    angular.forEach( json.menus.items, function(item) {
	       if( item.icon ){
	         $scope.menuItemClass = 'item-icon-left';
	       }
	    });

		$scope.menus = json;

		var apptheme = json['meta']['design']['app_theme'];
		if( 'default' !== apptheme ) {
			$rootScope.theme = 'css/'+ apptheme +'.css' ;
		}

		// load css into head
		var background = json['meta']['design']['toolbar_background'];
		var color = json['meta']['design']['toolbar_color'];

		var toolbar = '.bar-reactor { background-color:' + background + '; border-bottom:' + background + '; } .bar-reactor h1, .bar-reactor .button { color: ' + color + '; } .post-category { color: ' + background + '; } ';


		var view_background = 'body, .menu, .pane, .view, .cardlist-class, .card-class, .pinlist-class { background-color: '+json['meta']['design']['view_background']+'; color: '+json['meta']['design']['text_color']+'; } ';
		var list_background = '.item-complex .item-content, .pin, .card, .item  { background-color: '+json['meta']['design']['list_background']+'; border-color: '+json['meta']['design']['border_color']+';} ';
		var text_color = '.item, .item p, h1, h2, h3, h4, h5, h6, h7, h8, h9, a, .pin-category, .post-category { color: '+json['meta']['design']['text_color']+'} ';
		var border_color = '.pin .pin-header, .pin .pin-footer, .comment-header, .res-col-item:last-child, .product-slider { border-color: '+json['meta']['design']['border_color']+'; } ';
		var button = '.button.button-positive, .button.button-positive.activated { background-color: '+json['meta']['design']['button_background']+'; color: '+json['meta']['design']['button_color']+';   } ';

		var customCSS = json['meta']['design']['custom_css'];

		$rootScope.styles = toolbar + view_background + list_background + text_color + border_color + button + customCSS ;
		$scope.apptitle = json['meta']['name'];

		// iad display
		if( 'on' === json['meta']['iad'] ) {

			setTimeout(function() {

			    if ( window.plugins && window.plugins.iAd ) {
			        window.plugins.iAd.createBannerView({
			            'bannerAtTop': false,
			            'overlap': false,
			            'offsetTopBar' : false
			                }, function() {
			                    window.plugins.iAd.showAd( true );
			                }, function(){
			                    console.log( "failed to create ad view" );
			                });
			    } else {
			        console.error('iAd plugin not available/ready.');
			    }

		    }, 2000);

		}
		// admob display
		if( null !== json['meta']['admob'] ) {

			setTimeout(function() {

				if(AdMob && admobid) {
					AdMob.createBanner( {
					    adId: admobid.banner,
					    position: AdMob.AD_POSITION.BOTTOM_CENTER,
					    autoShow: true
					} );
				} else {
					console.error('Admob plugin not available/ready.');
				}

		    }, 2000);

		}

	}

	// gets menu id on tap
	$scope.menuID = function(id) {
		pageID = id;
		isMenuTap = true;
		console.log(pageID);
	}

});
