app.factory( 'DataLoader', function( $http, $stateParams, $location, $rootScope ){

	return {

		// gets the app config data
		getAppData: function(location) {

			return $http({
			  url: location,
			  method: 'GET'
			});

		},

		// the messaiah of posts data
		getData: function( url, params ) {
			return $http.jsonp( url, { params: params } );
		},

		// loads language strings
		loadLanguage: function() {
		
			var lang = language.toLowerCase();

			var langData = $http.get('i18n/' + lang + '.json');

			langData.success( function(  data, status, headers ){
				console.log('language file loaded');
				REACTOR_TEXT = data[0];
				$rootScope.ptrText = REACTOR_TEXT['ptr_text'];

			});

			langData.error( function(  data, status, headers ){
				console.error('requested language file not loaded');
				$http.get('i18n/en-us.json').success( function(  data, status, headers ){
					console.log('default language file loaded');
					REACTOR_TEXT = data[0];
					$rootScope.ptrText = REACTOR_TEXT['ptr_text'];
				});
			});
		}

	} ///return

});
